using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Identity;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using LoginApp.Models;

namespace LoginApp.Pages
{
    public class CreateUserModel : PageModel
    {
        readonly IConfiguration _configuration;

        private string connectionString;

        public CreateUserModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {

        }

        public void OnPost()
        {
            CreateUser();
        }

        void CreateUser()
        {
            Person person = new Person();
            string userName;
            string password;

            connectionString = _configuration.GetConnectionString("ConnectionString");

            person.FullName = Request.Form["FullName"];
            userName = Request.Form["EMail"];
            password = Request.Form["Password"];

            person.EMail = userName;
            person.Password = PasswordHash(userName, password);

            person.CreateUser(connectionString, person);


            Response.Redirect("./User");
        }


        string PasswordHash(string userName, string password)
        {

            PasswordHasher<string> pw = new PasswordHasher<string>();

            string passwordHashed = pw.HashPassword(userName, password);

            return passwordHashed;

        }

    }
}
