using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Identity;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Http;
using LoginApp.Models;

namespace LoginApp.Pages
{
    public class UpdateUserModel : PageModel
    {
        readonly IConfiguration _configuration;

        private string connectionString;

        public string userName = null;
        public int validUser = 0;

        public Person personDB = new Person();

        public UpdateUserModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            VerifyLogin();

            GetUserInformation();
        }

        public void OnPost()
        {
            VerifyLogin();

            UpdateUser();
        }

        void GetUserInformation()
        {
            Person person = new Person();

            connectionString = _configuration.GetConnectionString("ConnectionString");

            personDB = person.GetUserData(connectionString, userName);

        }

        void VerifyLogin()
        {
            if (HttpContext.Session.GetInt32("Login") != null)
                validUser = (int)HttpContext.Session.GetInt32("Login");
            else
            { 
                validUser = 0;
                Response.Redirect("./Error");
            }

            if (HttpContext.Session.GetString("UserName") != null)
                userName = HttpContext.Session.GetString("UserName");
            else
                userName = null;
        }


        void UpdateUser()
        {
            Person person = new Person();
            string userName;
            string password;

            connectionString = _configuration.GetConnectionString("ConnectionString");

            person.PersonId = Convert.ToInt32(Request.Form["PersonId"]);
            person.FullName = Request.Form["FullName"];
            userName = Request.Form["EMail"];
            password = Request.Form["Password"];

            person.EMail = userName;
            person.Password = PasswordHash(userName, password);

            person.UpdateUser(connectionString, person);

            Response.Redirect("./User");
        }


        string PasswordHash(string userName, string password)
        {

            PasswordHasher<string> pw = new PasswordHasher<string>();

            string passwordHashed = pw.HashPassword(userName, password);

            return passwordHashed;

        }

    }
}
